plugins['userpopup'] = (function() {

    var popup_title = pluginconfig['userpopup']['popup_title'][''];
    var popup_subtitle = pluginconfig['userpopup']['popup_subtitle'][''];
    var warningContent = Base64.decode(pluginconfig['userpopup']['warning_content']['']);
    var imagePath = pluginconfig['userpopup']['image_path'][''];	

    // 30 days
    var time_to_live = 60 * 60 * 24 * 30 * 1000;

    // Gerar um hash baseado no título e no conteúdo
    var messageData = popup_title + popup_subtitle + warningContent;
    var messageHash = btoa(unescape(encodeURIComponent(messageData)));

    return {

        loadLang: function(values) {
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~userpopup" + "|" + hash + "\" />";
            sendcommand();
        },
        setLang: function() {
            $('.userpopuptitle').html(lang.set_user_notifications);
        },
        showWarning: function() {
            // Get last message hash from localstorage, no matter if expired
            last_notice = plugins['userpopup'].getWithExpiry('fop2userpopup',0);
            if(last_notice != messageHash) {
                // New message on plugin configuration/ini, store it in localstorage to replace previous one
                plugins['userpopup'].setWithExpiry('fop2userpopup',messageHash,time_to_live);
            }
            // Check for shown status in localstorage, do not show if expired 
            last_notice = plugins['userpopup'].getWithExpiry('fop2userpopup',1);
            if(last_notice !== null) {
                if($('#userpopupdialog').length <= 0) {
                    var newklon = $(
                    '<link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">' +
                        '<div id="userpopupdialog" class="modal fade" role="dialog">' +
                            '<div class="modal-dialog modal-lg" role="document">' +
                                '<div class="modal-content">' +
                                    '<div class="modal-header">' +
                                        '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>' +
                                        '<div style="display: flex; align-items: center;">' +
                                            '<span class="material-icons" style="margin-right: 10px;">notifications_active</span>' +
                                            '<h3 class="modal-title">' + popup_title + '</h3>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="modal-body" style="display: flex;">' +
                                        '<div style="flex: 1; display: flex; justify-content: center; align-items: center;">' +
                                            '<img src="' + imagePath + '" style="max-width: 100%; height: auto;">' +
                                        '</div>' +
                                        '<div style="flex: 1;">' +
                                            '<h4 style="font-size: 2.25em; margin-bottom: 20px;">' + popup_subtitle + '</h4>' +
                                            '<p style="font-size: 1.2em; color: #333;">' + warningContent + '</p>' +
                                        '</div>' +
                                    '</div>' +
                                    '<div class="modal-footer">' +
                                        '<button class="btn btn-danger" data-dismiss="modal">'+lang.cancel+'</button>' +
                                        '<button class="btn btn-success" data-dismiss="modal">'+lang.accept+'</button>' +
                                    '</div>' +
                                '</div>' +
                            '</div>' +
                        '</div>'
                    );
                    $('body').append(newklon);
                    $('#userpopupdialog').modal('show');

                    // Evento de clique no botão Aceitar para armazenar a aceitação da mensagem
                    $('#userpopupdialog .btn-success').click(function() {
                        plugins['userpopup'].setWithExpiry('fop2userpopup',messageHash,1);
                    });
                }
            }
        },
        setWithExpiry: function(key, value, ttl) {
            const now = new Date()
            const item = {
                value: value,
                expiry: now.getTime() + ttl,
            }
            localStorage.setItem(key, JSON.stringify(item))
        },
        getWithExpiry: function(key,checkexpiry) {
            const itemStr = localStorage.getItem(key)
            // if the item doesn't exist, return null
            if (!itemStr) {
                return null
            }
            const item = JSON.parse(itemStr)
            const now = new Date()
            // compare the expiry time of the item with the current time
            if (now.getTime() > item.expiry && checkexpiry==1) {
                // If the item is expired return null
                return null
            }
            return item.value
        },
        init: function() {

            if(permisos.includes('adminuserpopup') || permisos.includes('all')) {

                if($('#userpopupcontainer').length==0) {
                    $('body').append(" <div id='userpopupcontainer' class='modal fade' role='dialog'> <div class='modal-dialog modal-lg' role='document'> <div class='modal-content'> <div class='modal-header'> <button type='button' class='close' data-dismiss='modal' aria-hidden='true'>&times;</button> <div class='content'><span class='fa fa-exclamation-triangle pull-left' style='padding: 7px 5px; font-size:1.5em;'></span><h3 class='modal-title userpopuptitle'>Edit User Popup</h3></div> </div> <div class='modal-body'> <iframe id='iframeuserpopup' src='' width='100%' height='600px' frameborder='0'></iframe></div></div></div></div> ");
                }

                if($('#liuserpopupmenu').length==0) {
                    ponerenpos = ($("#usermenu li").length) - 2;
                    $("#usermenu li:nth-child(" + ponerenpos + ")").after("<li role='presentation' id='liuserpopupmenu'><a role='menuitem' id='menuuserpopup'><span class='fa fa-exclamation-triangle'></span> <span class='userpopuptitle'>Set User Notification</span></a></li>");

                    $('#menuuserpopup').click(function(e) {
                        console.log("click on menu userpopup");
                        showEditUserPopup();
                    });
                }

                var showEditUserPopup = function() {
                    if($('#iframeuserpopup').attr('src')=='') {
                        $('#iframeuserpopup').attr('src','admin/plugins/userpopup/userpopup.php');
                    }
                    $('#userpopupcontainer').modal();
                }

            }

            this.showWarning();
        }
    }
}());

plugins['userpopup'].init();
