<?php
header("Content-Type: text/html; charset=utf-8");
require_once("../../../config.php");
require_once("../../asmanager.php");
require_once("../../functions.php");

$mylang = $_SESSION[MYAP]['language'];

$astman = new AsteriskManager();


function read_file_to_array($file_path)
{
    global $mylang;
    $lang = array();
    $lines = file($file_path, FILE_IGNORE_NEW_LINES);

    foreach ($lines as $line) {
        if (strpos($line, 'lang[') === 0) {
            $parts = explode('=', $line, 2);
            $key = substr(trim($parts[0]),6,-2);
            $value = substr(trim($parts[1]),1,-2);
            $lang[$mylang][$key] = $value;
        }
    }

    return $lang;
}

if(is_file("lang/$mylang.js")) {
    $newlang = read_file_to_array("lang/$mylang.js");
} else {
    $newlang = read_file_to_array("lang/en.js");
}
$merged_array = array_merge_recursive($lang, $newlang);
$lang = $merged_array;

$conf=array();
if(is_file("/usr/local/fop2/fop2.cfg") || is_file("/etc/asterisk/fop2/fop2.cfg")) {
   if(is_file("/usr/local/fop2/fop2.cfg")) {
       $fop2conf = parse_conf("/usr/local/fop2/fop2.cfg");
   }
   if(is_file("/etc/asterisk/fop2/fop2.cfg")) {
       $fop2conf = parse_conf("/etc/asterisk/fop2/fop2.cfg");
   }
   if(isset($fop2conf['manager_port'])) {
       $conf['MGRPORT']=$fop2conf['manager_port'];
   } else {
       $conf['MGRPORT']=5038;
   }
   if(isset($fop2conf['manager_user'])) {
       $conf['MGRUSER']=$fop2conf['manager_user'];
   } else {
       $conf['MGRUSER']=5038;
   }
   if(isset($fop2conf['manager_host'])) {
       $conf['MGRHOST']=$fop2conf['manager_host'];
   } else {
       $conf['MGRHOST']='127.0.0.1';
   }
   if(isset($fop2conf['manager_secret'])) {
       $conf['MGRPASS']=$fop2conf['manager_secret'];
   } else {
       $conf['MGRPASS']=5038;
   }
}

$context   = $_SESSION[MYAP]['context'];
$extension = $_SESSION[MYAP]['extension'];

if(!$resman = $astman->connect($conf["MGRHOST"].":".$conf["MGRPORT"], $conf["MGRUSER"] , $conf["MGRPASS"], 'off')) {
    unset($astman);
}


$permit    = $_SESSION[MYAP]['permit'];
$admin     = isset($_SESSION[MYAP]['admin'])?$_SESSION[MYAP]['admin']:0;
$permisos  = preg_split("/,/",$permit);

if(in_array("adminuserpopup",$permisos) || in_array("all",$permisos)) {
    $allowed='yes';
} else {
    $allowed='no';
}

$jscode="";
$popup_title="";
$popup_subtitle="";
$image_path="";
$warning_content="";

if($allowed=='yes') {

    if(isset($_POST['popup_title'])) {
        // save ini
        $array_final = array(
          "popup_title"=>$_POST['popup_title'],
          "popup_subtitle"=>$_POST['popup_subtitle'],
          "image_path"=>$_POST['image_path'],
          "warning_content"=>base64_encode($_POST['warning_content'])
        );

        $res = array();
        foreach($array_final as $key => $val)
        {
            if(is_array($val))
            {
                $res[] = "[$key]";
                foreach($val as $skey => $sval) $res[] = "$skey = ".(is_numeric($sval) ? $sval : '"'.$sval.'"');
            }
            else $res[] = "$key = ".(is_numeric($val) ? $val : '"'.$val.'"');
        }

        $ret = file_put_contents("userpopup.ini", implode("\n", $res), LOCK_EX);
        if($ret===false) {
            $jscode="parent.alertify.error('Error saving data');";
        } else {
            $jscode="parent.alertify.success('Data saved'); parent.$('#userpopupcontainer').modal('hide')";
            if($resman!==false) {
                $resman = $astman->UserEvent('FOP2RELOAD',array('Channel'=>'Zap/1'));
            }
        }
        
    }

    // Read current ini file before extraction and save its values
    $ini_array = array();
    $current_inifile = substr(escapeshellarg("userpopup.ini"),1,-1);
    if(file_exists($current_inifile)) {
        $ini_array = parse_ini_file($current_inifile, true);
        extract($ini_array);
        $warning_content= base64_decode($warning_content);
    }
}

?>
<!DOCTYPE html>
<html>
<head>
    <base href='../../../'>
    <meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
    <meta http-equiv="imagetoolbar" content="false"/>
    <meta name="MSSmartTagsPreventParsing" content="true"/>
    <meta name="description" content=""/>
    <meta name="keywords" content=""/>
    <link rel="stylesheet" type="text/css" href="css/jconf.css" />
    <link rel="stylesheet" type="text/css" href="css/chosen.css" />
    <link rel="stylesheet" type="text/css" href="css/jquery.noty.css" />
    <link href="css/bootstrap.min.css" media="screen" rel="stylesheet" type="text/css">
    <link rel="stylesheet" type="text/css" href="css/bootstrap.datepicker.css" />
    <link rel="stylesheet" type="text/css" href="css/dbgrid.css" />
    <link rel="stylesheet" type="text/css" href="css/flags.css" />
    <link rel="stylesheet" type="text/css" href="css/animate.css" />
    <link href="css/bootstrap-select.css" media="screen" rel="stylesheet" type="text/css">
    <script src="js/jquery-1.11.3.min.js" type="text/javascript"></script>
    <script src="js/moment-with-locales.js"></script>
    <script type="text/javascript" src="js/jquery.plugin.js"></script>
    <script type="text/javascript" src="js/jquery.noty.js"></script>
    <script type="text/javascript" src="js/chosen.jquery.min.js"></script>
    <script type="text/javascript" src="js/jquery.jconf.js"></script>
    <script src="js/bootstrap.min.js" type="text/javascript"></script>
    <script src="js/bootstrap-switch.min.js" type="text/javascript"></script>
    <script src="js/bootstrap-dropdown-on-hover.js " type="text/javascript"></script>
    <script type="text/javascript" src="js/bootstrap.datepicker.js"></script>
    <script type="text/javascript" src="js/jquery.datetimeentry.js"></script>
    <script type="text/javascript" src="js/jquery.tools.form.min.js"></script>
    <script type="text/javascript" src="js/jquery.colresizable.min.js"></script>
    <script type="text/javascript" src="js/jquery.browser.js"></script>
    <script type="text/javascript" src="js/jquery.autoheight.js"></script>
    <script src="js/bootstrap-select.js" type="text/javascript"></script>
</head>
<body>
<?php 
if($allowed=='no') {
?>
<h1>Not allowed</h1>
<?php
} else {
?>
<form method='post'>
  <div class="form-group">
    <label for="popup_title"><?php echo trans('Popup Title');?></label>
    <input type="text" class="form-control" name="popup_title" id="popup_title" placeholder="<?php echo trans('Title');?>" value="<?php echo $popup_title;?>">
  </div>
  <div class="form-group">
    <label for="popup_subtitle"><?php echo trans('Popup Subtitle');?></label>
    <input type="text" class="form-control" name="popup_subtitle" id="popup_subtitle" placeholder="<?php echo trans('Subtitle');?>" value="<?php echo $popup_subtitle;?>">
  </div>
  <div class="form-group">
    <label for="warning_content"><?php echo trans('Warning Content');?></label>
    <textarea rows=6 name='warning_content' id='warning_content' class='form-control'><?php echo $warning_content;?></textarea>
  </div>
  <div class="form-group">
    <label for="image_path"><?php echo trans('Image Path');?></label>
    <input type="text" class="form-control" name="image_path" id="image_path" placeholder="/path/to/image.png" value="<?php echo $image_path;?>">
  </div>
<div class="form-group">
  <button type="submit" class="btn btn-primary pull-right" style='margin-left:2px;margin-right:2px;'><?php echo trans('Save');?></button>
  <button id='btncancel' class="btn btn-danger pull-right" style='margin-left:2px;margin-right:2px;' data-dismiss="modal"><?php echo trans('Cancel');?></button>
</div>
</form>
<?php  } ?>

<script>
<?php echo $jscode;?>



$('#btncancel').on('click',function(e) {
    e.preventDefault();
    parent.$('#userpopupcontainer').modal('hide');
    return false;
});
</script>
</body>
</html>
